/*!
 * jQuery Fancy Buttons Plugin 1.0
 * https://github.com/skyfoxdesign/fancy-buttons
 *
 * @author Piers Elliott (hello@skyfox.design)
 * Included is a modified versions of Transit.js and jQuery Touch Plugin
 *
 * jQuery Transit - CSS3 transitions and transformations
 * (c) 2011-2014 Rico Sta. Cruz
 * MIT Licensed.
 *
 * http://ricostacruz.com/jquery.transit
 * http://github.com/rstacruz/jquery.transit
 *
 * jQuery Touch Plugin 1.0.1
 * https://github.com/upwards/jquery-touch
 *
 * @autor Alexey Kupriyanenko (a.kupriyanenko@gmail.com)
 */

var hoverable = true

var buttonClass = "fancy-button",
  buttonContainer = "fancy-buttonContainer", 
  buttonOverlayContainer = "fancy-buttonOverlayContainer",
  buttonOverlay = "fancy-buttonOverlay";

function assemble(){$("."+buttonClass).each(function(){$(this).wrap("<div class='"+buttonContainer+"'></div>").prepend("<div class='"+buttonOverlayContainer+"'><div class="+buttonOverlay+"></div></div>")})}function kill(t){window.document.body.addEventListener(t,function(t){return t.preventDefault(),t.stopPropagation(),!1},!0)}function activeTransition(t){return{perspective:2*Math.max(width,height),duration:$(t).is(hover)?0:100,rotateX:-clampedY+"deg",rotateY:clampedX+"deg",scale:1-scaleVariance}}function reenterTransition(t){return{perspective:2*Math.max(width,height),duration:100,rotateX:-clampedY+"deg",rotateY:clampedX+"deg",scale:1-scaleVariance}}function inactiveTransition(t){$(t).stopTransition().transition({duration:500,rotateX:"0deg",rotateY:"0deg",scale:1}),$(t).children("."+buttonOverlayContainer).stopTransition().transition({duration:500,opacity:"0"}),hover=null,down=!1}function initialOpacity(t){return{duration:$(t).is(hover)?0:200,opacity:1}}function gradient(t){return{duration:0,opacity:opacityVariance,background:"-webkit-gradient(linear,"+(percentX+2*inverseX)+"% "+(percentY+2*inverseY)+"%,"+(inverseX-2*percentX)+"% "+(inverseY-2*percentY)+"%, from(rgba(0,0,0,0.5)), to(rgba(255,255,255,0.4)))"}}function calculateVar(t,e,n,i,s){width=$(s).outerWidth(),height=$(s).outerHeight(),percentX=(t-n)/width*100,percentY=(e-i)/height*100,clampedX=Math.min(10,Math.max(-10,(percentX-50)/3)),clampedY=Math.min(10,Math.max(-10,(percentY-50)/3)),inverseX=100-percentX,inverseY=100-percentY,opacityVariance=(100-Math.min(100-2*Math.abs(percentX-50),100-2*Math.abs(percentY-50)))/100,scaleVariance=Math.min(.05-Math.abs((percentX-50)/1e3),.05-Math.abs((percentY-50)/1e3)),$(s).children("."+buttonOverlayContainer).stop().transition(initialOpacity(s)),$(s).find("."+buttonOverlay).transition(gradient(s))}function triggerEnter(t,e){$("."+buttonClass).each(function(){t<=$(this).offset().left||t>=$(this).offset().left+$(this).outerWidth()||e<=$(this).offset().top||e>=$(this).offset().top+$(this).outerHeight()?$(this).is(hover)&&$(this).stopTransition().transition(inactiveTransition(hover)):$(this).is(hover)?(calculateVar(t,e,this.offsetLeft,this.offsetTop,this),$(this).stopTransition().transition(activeTransition(this))):(calculateVar(t,e,this.offsetLeft,this.offsetTop,this),$(this).stopTransition().transition(reenterTransition(this)),null!==hover&&inactiveTransition(hover),hover=$(this))})}assemble(),!function(t,e){"function"==typeof define&&define.amd?define(["jquery"],e):"object"==typeof exports?module.exports=e(require("jquery")):e(t.jQuery)}(this,function(t){function e(t){if(t in h.style)return t;for(var e=["Moz","Webkit","O","ms"],n=t.charAt(0).toUpperCase()+t.substr(1),i=0;i<e.length;++i){var s=e[i]+n;if(s in h.style)return s}}function n(){return h.style[l.transform]="",h.style[l.transform]="rotateY(90deg)",""!==h.style[l.transform]}function i(t){return"string"==typeof t&&this.parse(t),this}function s(t,e,n){e===!0?t.queue(n):e?t.queue(e,n):t.each(function(){n.call(this)})}function a(e){var n=[];return t.each(e,function(e){e=t.camelCase(e),e=t.transit.propertyMap[e]||t.cssProps[e]||e,e=c(e),l[e]&&(e=c(l[e])),-1===t.inArray(e,n)&&n.push(e)}),n}function r(e,n,i,s){var r=a(e);t.cssEase[i]&&(i=t.cssEase[i]);var o=""+f(n)+" "+i;parseInt(s,10)>0&&(o+=" "+f(s));var c=[];return t.each(r,function(t,e){c.push(e+" "+o)}),c.join(", ")}function o(e,n){n||(t.cssNumber[e]=!0),t.transit.propertyMap[e]=l.transform,t.cssHooks[e]={get:function(n){var i=t(n).css("transit:transform");return i.get(e)},set:function(n,i){var s=t(n).css("transit:transform");s.setFromString(e,i),t(n).css({"transit:transform":s})}}}function c(t){return t.replace(/([A-Z])/g,function(t){return"-"+t.toLowerCase()})}function u(t,e){return"string"!=typeof t||t.match(/^[\-0-9\.]+$/)?""+t+e:t}function f(e){var n=e;return"string"!=typeof n||n.match(/^[\-0-9\.]+/)||(n=t.fx.speeds[n]||t.fx.speeds._default),u(n,"ms")}t.transit={version:"0.9.12",propertyMap:{marginLeft:"margin",marginRight:"margin",marginBottom:"margin",marginTop:"margin",paddingLeft:"padding",paddingRight:"padding",paddingBottom:"padding",paddingTop:"padding"},enabled:!0,useTransitionEnd:!1};var h=document.createElement("div"),l={},p=navigator.userAgent.toLowerCase().indexOf("chrome")>-1;l.transition=e("transition"),l.transitionProp=e("transitionProperty"),l.transitionDelay=e("transitionDelay"),l.transform=e("transform"),l.transformOrigin=e("transformOrigin"),l.filter=e("Filter"),l.transform3d=n();var d={transition:"transitionend",MozTransition:"transitionend",OTransition:"oTransitionEnd",WebkitTransition:"webkitTransitionEnd",msTransition:"MSTransitionEnd"},v=l.transitionEnd=d[l.transition]||null;for(var b in l)l.hasOwnProperty(b)&&"undefined"==typeof t.support[b]&&(t.support[b]=l[b]);return h=null,t.cssEase={_default:"ease","in":"ease-in",out:"ease-out","in-out":"ease-in-out",snap:"cubic-bezier(0,1,.5,1)",easeInCubic:"cubic-bezier(.550,.055,.675,.190)",easeOutCubic:"cubic-bezier(.215,.61,.355,1)",easeInOutCubic:"cubic-bezier(.645,.045,.355,1)",easeInCirc:"cubic-bezier(.6,.04,.98,.335)",easeOutCirc:"cubic-bezier(.075,.82,.165,1)",easeInOutCirc:"cubic-bezier(.785,.135,.15,.86)",easeInExpo:"cubic-bezier(.95,.05,.795,.035)",easeOutExpo:"cubic-bezier(.19,1,.22,1)",easeInOutExpo:"cubic-bezier(1,0,0,1)",easeInQuad:"cubic-bezier(.55,.085,.68,.53)",easeOutQuad:"cubic-bezier(.25,.46,.45,.94)",easeInOutQuad:"cubic-bezier(.455,.03,.515,.955)",easeInQuart:"cubic-bezier(.895,.03,.685,.22)",easeOutQuart:"cubic-bezier(.165,.84,.44,1)",easeInOutQuart:"cubic-bezier(.77,0,.175,1)",easeInQuint:"cubic-bezier(.755,.05,.855,.06)",easeOutQuint:"cubic-bezier(.23,1,.32,1)",easeInOutQuint:"cubic-bezier(.86,0,.07,1)",easeInSine:"cubic-bezier(.47,0,.745,.715)",easeOutSine:"cubic-bezier(.39,.575,.565,1)",easeInOutSine:"cubic-bezier(.445,.05,.55,.95)",easeInBack:"cubic-bezier(.6,-.28,.735,.045)",easeOutBack:"cubic-bezier(.175, .885,.32,1.275)",easeInOutBack:"cubic-bezier(.68,-.55,.265,1.55)"},t.cssHooks["transit:transform"]={get:function(e){return t(e).data("transform")||new i},set:function(e,n){var s=n;s instanceof i||(s=new i(s)),"WebkitTransform"!==l.transform||p?e.style[l.transform]=s.toString():e.style[l.transform]=s.toString(!0),t(e).data("transform",s)}},t.cssHooks.transform={set:t.cssHooks["transit:transform"].set},t.cssHooks.filter={get:function(t){return t.style[l.filter]},set:function(t,e){t.style[l.filter]=e}},t.fn.jquery<"1.8"&&(t.cssHooks.transformOrigin={get:function(t){return t.style[l.transformOrigin]},set:function(t,e){t.style[l.transformOrigin]=e}},t.cssHooks.transition={get:function(t){return t.style[l.transition]},set:function(t,e){t.style[l.transition]=e}}),o("scale"),o("scaleX"),o("scaleY"),o("translate"),o("rotate"),o("rotateX"),o("rotateY"),o("rotate3d"),o("perspective"),o("skewX"),o("skewY"),o("x",!0),o("y",!0),i.prototype={setFromString:function(t,e){var n="string"==typeof e?e.split(","):e.constructor===Array?e:[e];n.unshift(t),i.prototype.set.apply(this,n)},set:function(t){var e=Array.prototype.slice.apply(arguments,[1]);this.setter[t]?this.setter[t].apply(this,e):this[t]=e.join(",")},get:function(t){return this.getter[t]?this.getter[t].apply(this):this[t]||0},setter:{rotate:function(t){this.rotate=u(t,"deg")},rotateX:function(t){this.rotateX=u(t,"deg")},rotateY:function(t){this.rotateY=u(t,"deg")},scale:function(t,e){void 0===e&&(e=t),this.scale=t+","+e},skewX:function(t){this.skewX=u(t,"deg")},skewY:function(t){this.skewY=u(t,"deg")},perspective:function(t){this.perspective=u(t,"px")},x:function(t){this.set("translate",t,null)},y:function(t){this.set("translate",null,t)},translate:function(t,e){void 0===this._translateX&&(this._translateX=0),void 0===this._translateY&&(this._translateY=0),null!==t&&void 0!==t&&(this._translateX=u(t,"px")),null!==e&&void 0!==e&&(this._translateY=u(e,"px")),this.translate=this._translateX+","+this._translateY}},getter:{x:function(){return this._translateX||0},y:function(){return this._translateY||0},scale:function(){var t=(this.scale||"1,1").split(",");return t[0]&&(t[0]=parseFloat(t[0])),t[1]&&(t[1]=parseFloat(t[1])),t[0]===t[1]?t[0]:t},rotate3d:function(){for(var t=(this.rotate3d||"0,0,0,0deg").split(","),e=0;3>=e;++e)t[e]&&(t[e]=parseFloat(t[e]));return t[3]&&(t[3]=u(t[3],"deg")),t}},parse:function(t){var e=this;t.replace(/([a-zA-Z0-9]+)\((.*?)\)/g,function(t,n,i){e.setFromString(n,i)})},toString:function(t){var e=[];for(var n in this)if(this.hasOwnProperty(n)){if(!l.transform3d&&("rotateX"===n||"rotateY"===n||"perspective"===n||"transformOrigin"===n))continue;"_"!==n[0]&&(t&&"scale"===n?e.push(n+"3d("+this[n]+",1)"):t&&"translate"===n?e.push(n+"3d("+this[n]+",0)"):e.push(n+"("+this[n]+")"))}return e.join(" ")}},t.fn.transition=t.fn.transit=function(e,n,i,a){var o=this,c=0,u=!0,h=t.extend(!0,{},e);"function"==typeof n&&(a=n,n=void 0),"object"==typeof n&&(i=n.easing,c=n.delay||0,u="undefined"==typeof n.queue||n.queue,a=n.complete,n=n.duration),"function"==typeof i&&(a=i,i=void 0),"undefined"!=typeof h.easing&&(i=h.easing,delete h.easing),"undefined"!=typeof h.duration&&(n=h.duration,delete h.duration),"undefined"!=typeof h.complete&&(a=h.complete,delete h.complete),"undefined"!=typeof h.queue&&(u=h.queue,delete h.queue),"undefined"!=typeof h.delay&&(c=h.delay,delete h.delay),"undefined"==typeof n&&(n=t.fx.speeds._default),"undefined"==typeof i&&(i=t.cssEase._default),n=f(n);var p=r(h,n,i,c),d=t.transit.enabled&&l.transition,b=d?parseInt(n,10)+parseInt(c,10):0;if(0===b){var g=function(t){o.css(h),a&&a.apply(o),t&&t()};return s(o,u,g),o}var m={},y=function(e){var n=!1,i=function(){n&&o.unbind(v,i),b>0&&o.each(function(){this.style[l.transition]=m[this]||null}),"function"==typeof a&&a.apply(o),"function"==typeof e&&e()};if(b>0&&v&&t.transit.useTransitionEnd)n=!0,o.bind(v,i);else{var s=window.setTimeout(i,b);o.data("timerCallback",s)}o.each(function(){b>0&&(this.style[l.transition]=p),t(this).css(h)})},T=function(t){this.offsetWidth,y(t)};return s(o,u,T),this},t.fn.stopTransition=t.fn.stopTransit=function(e){return this.each(function(){var n=t(this),i=this.style[l.transitionProp].replace(/\s+/g,"");if(i&&0!=i.length)for(var s=window.getComputedStyle(this),a=i.split(","),r=0;r<a.length;r++){var o=a[r];this.style[o]=s[o]}if(this.style[l.transitionProp]="",this.style[l.transition]="none",e===!0){var c=elm.data("transitCallback");c&&c()}n.data("transitCallback",null),t.transit.useTransitionEnd?n.unbind(v):window.clearTimeout(n.data("timerCallback")),n.clearQueue()}),this},t.transit.getTransitionValue=r,t});var isTouchStateLeave=function(t){var e=t.offset().left,n=t.offset().top,i=t.outerWidth()+e,s=t.outerHeight()+n;touchX=event.touches[0].pageX,touchY=event.touches[0].pageY;var a=touchX>e&&touchX<i&&touchY>n&&touchY<s;return!a};jQuery.fn.extend({touchleave:function(t){return $(this).each(function(){if(void 0!=this){var e=this,n=$(this),i=!0;e.addEventListener("touchstart",function(t){},!1),e.addEventListener("touchmove",function(s){isTouchStateLeave(n)?(i&&t.call(e,s),i=!1):i=!0},!1)}}),this}}),document.addEventListener("touchstart",function(){},!0);var isTouch="ontouchstart"in window;isTouch&&(kill("mousedown"),kill("mouseup"),kill("mousemove"));var hover=null,click=!1,down=!1,width,height,percentX,percentY,amountX,amountY,clampedX,clampedY,divergenceX,divergenceY,inverseX,inverseY,scaleVariance,opacityVariance,element;$("."+buttonClass).on("mousemove",function(t){hoverable===!0?$(this).is(hover)?(calculateVar(t.pageX,t.pageY,this.offsetLeft,this.offsetTop,this),$(this).css(activeTransition(this))):(calculateVar(t.pageX,t.pageY,this.offsetLeft,this.offsetTop,this),$(this).stopTransition().transition(activeTransition(this)),hover=$(this)):down&&(calculateVar(t.pageX,t.pageY,this.offsetLeft,this.offsetTop,this),$(this).css(activeTransition(this)))}),$("."+buttonClass).on("touchstart",function(t){click=!0,calculateVar(t.pageX,t.pageY,this.offsetLeft,this.offsetTop,this),click=!1,$(this).stopTransition().transition(activeTransition(this)),down=!0,hover=$(this)}),$("."+buttonClass).mousedown(function(t){click=!0,calculateVar(t.pageX,t.pageY,this.offsetLeft,this.offsetTop,this),click=!1,$(this).stopTransition().transition(activeTransition(this)),hover=$(this),down=!0}),hoverable===!0?($("."+buttonClass).on("touchmove",function(t){t.preventDefault();t.originalEvent.touches[0];triggerEnter(t.pageX,t.pageY)}),$("."+buttonClass).on("touchend",function(){null!==hover&&inactiveTransition(hover)}),$("."+buttonContainer).on("mouseleave",function(){var t=$(this).children("."+buttonClass);inactiveTransition(t)})):($("."+buttonClass).on("touchmove",function(t){down&&(calculateVar(t.pageX,t.pageY,this.offsetLeft,this.offsetTop,this),$(this).css(activeTransition(this)),t.preventDefault())}),$("."+buttonClass).on("mousemove",function(t){down&&(calculateVar(t.pageX,t.pageY,this.offsetLeft,this.offsetTop,this),$(this).css(activeTransition(this)))}),$("."+buttonClass).on("mouseup",function(){inactiveTransition(this)}),$("."+buttonClass).on("touchend",function(){inactiveTransition(this)}),$("."+buttonClass).on("mouseleave",function(){inactiveTransition(this)}),$("."+buttonClass).touchleave(function(){inactiveTransition(this)}));
